// elimination with different orderings: 
// activate option(prot) to see what's going on

option(prot);

// e1: direct application
ring r = 0,(x,y,t),dp;

ideal I = x - t6, y + t8;

eliminate(I,t);

kill r;

// e2: with a product ordering

ring r2 = 0,(t,x,y),(dp(1),dp(2));

ideal I = x - t6, y + t8;

ideal J = std(I);  J;

kill r2;

// e3: with extra weight ordering

ring r3 = 0,(t,x,y),(a(1,0,0),dp);

ideal I = x - t6, y + t8;

ideal J = std(I); J;

kill r3;

// e3: with lexicographical ordering

ring r4 = 0,(t,x,y), lp;

ideal I = x - t6, y + t8;

ideal J = std(I); J;

kill r4;

// Question: who was the champion?

// Consider Example 6.2./6.3. from F. Winkler's lectures:
// we need to intersect the ideal with the subalgebra K[x,y]

option(prot);

LIB "elim.lib"; // for select

ring r1 = 0,(z,t,x,y),lp; //following the lecture of F.Winkler

ideal I = x*(256*t4 + 32*t2 + 1) + 1024*t3, y*(256*t4 + 32*t2 + 1) + 2048*t4 - 128*t2, (256*t4 + 32*t2 + 1)*z- 1;

ideal FW = eliminate(I,z*t); // one can always do the straightforward method

FW;

// but we do manual experiments

ideal J = groebner(I); J;

nselect(J,intvec(1,2));

kill r1;

// now let us use better ordering:

ring r2 = 0,(z,t,x,y),(a(1,1),dp); // extra weight elim ord

ideal I = x*(256*t4 + 32*t2 + 1) + 1024*t3, y*(256*t4 + 32*t2 + 1) + 2048*t4 - 128*t2, (256*t4 + 32*t2 + 1)*z- 1;

ideal J = groebner(I); J;

nselect(J,intvec(1,2));



