// computing a finite difference scheme
// for a given system of linear PDEs with const. coeffs

ring r = (0,A,dt,dh),(Tx,Tt),(c,dp);

// the following matrix acts
// on the vector (u_xx, u_x, u_tt, u_t, u)^T

matrix M[5][5]=

// direct equation:
-A^2, 0, 1, 0, 0,

// t: explicit (BT)
0,0, Tt*dt, 1-Tt, 0,
0,0,  0, Tt*dt, 1-Tt,

// x : trapezoid
1/2*dh*(Tx+1), 1-Tx, 0,0,0,
0, 1/2*dh*(Tx+1), 0,0,1-Tx;

// CHECK THE CORRECTNESS OF EQUATIONS:
ring rX = (0,A,dh,dt,Tx,Tt),(Uxx, Ux, Utt, Ut, U),(c,Dp);

matrix M = imap(r,M);

vector X = [Uxx, Ux, Utt, Ut, U];

print(M*X);

// END CHECK

setring r;

module R = transpose(M);

module S = groebner(R);

print(S);

poly     p = S[5,1]; // the scheme!!!

// now, try to use different module ordering like just (dp) == (dp,C)
// and convince yourself that one cannot get a scheme in the different way


// the only possibility:

ring r = (0,A,dt,dh),(Tx,Tt),(C,dp);

module N = M[5],M[4],M[3],M[2],M[1];

module R = transpose(N);

module S = groebner(R);

print(S);

poly p = S[1,1]; print(p);

// finita

