// solving inhomogeneous system + module membership

ring r = 0,(x,y,z),Dp;

poly f = x^2+y^2+z^2-2;

ideal A = x^2-y*z-1, y^2-x*z-1, z^2-x*y-1;

NF(f,A); // since A is not a GB this doen't say anything!

ideal G = groebner(A); // two elements

NF(f,G); // now we see it's zero

print(lift(G,f)); // the cofactors of f

vector xi0 = [-x*z+y*z-z^2, -x*z- x^2+x*y+2, -x*y+y^2- y*z]; // obtained by hands

print(matrix(A)*xi0 - f); // a quick test

module S = syz(A); S = groebner(S);

print(syz(A)); // syzygy module

print(S); //its Groebner basis

print( NF(xi0, S) );

quit;

// module membership
// note, that GB destroys symmetry

ring r = (0,K,p),(dx,dt),(C,dp);

matrix M[2][2] = 
dt, K*dx,
dx, p*dt;

M = transpose(M);
print(M);

module N = std(M);
print(N);

vector v = [0,-K*dx^2+p*dt^2];
print(v);

NF(v,N);

kill r;


