// FIELDS: finding
// primitive element for alg. extension
// and factorizing in such a field

LIB "primitiv.lib";

ring ex = 0,(x,y),dp;

ideal I = x2+1,y3-3;  

ideal M = primitive_extra(I);
M;

ring nx = (0,y),t,dp;

ideal S = imap(ex,M);

minpoly = leadcoef(S[1]);
nx;

number X = leadcoef(S[2]);
X^2;

factorize(t^3-3);

factorize(t^2+1);

kill nx; kill ex;

// factorization 2

ring r = (0,a),(x,y,z),Dp;

poly p = a7*x2*y - 343*xz*(y - (az +x)^3);

p; // prints p in the expanded form

factorize(p); // factorization

// factorization 3

ring r = 0,(x,y,z),dp;

// ugly-looking nonhomogeneous polynomial
poly p = x3y3z8-2x3y6z4-3x2y2z9+x3y9+2x5y3z4+6x2y5z5+3xyz10-2x5y6-3x2y8z-6x4y2z5-6xy4z6-z11+x7y3+6x4y5z+3xy7z2+6x3yz6+2y3z7-3x6y2z-6x3y4z2-y6z3-2x2z7+3x5yz2+2x2y3z3-x4z3;

p;  //(x2-y3+z4)^2*(xy-z)^3;

factorize(p);

kill r;

// SINGULAR as a black box:

// we solve an easy system

LIB "solve.lib";

ring rb = 0,(x,y,z),lp;

ideal I = 
  x2 + y + z-1,
  y2 + x + z-1,
  z3 + x + y-1;

ideal G = groebner(I);

G;

def RG = solve(G,17); // 7 correct decimal digits

setring RG;

SOL;

// SOLVING AGAIN

// std, slimgb and solving

LIB "solve.lib";

ring r  = 0,(x,y,z,u,v),dp;

ideal I = cyclic(5);

option(prot);

ideal J = slimgb(I);

ideal K = std(I);

dim(J);

// this will tell us how many *complex* solutions there are
vdim(J);

def S = solve(J);

setring S;

size(SOL);

SOL;

// arbitrary long integers
// either via char 0 or via bigint
ring r = 0,x,dp;

number a = 10;

a = (a+1)^11;
a;

a = (a+1)^11;
a;

a = (a+1)^11;
a;

kill r;
