LIB "poly.lib";
LIB "primdec.lib";

option(redSB); option(redTail); 

ring r = 0,(x,y,z,t),dp;

ideal I = cyclic(4);

ideal J = groebner(I);

dim(J);

list L = primdecGTZ(J);

L;

int s = size(L); int i; int d;

for(i=1; i<=s; i++)
{

  L[i][1] = groebner(L[i][1]);

  d       = dim(L[i][1]);

  printf("dim of %s- primary part is %s",i,d);

  if (d==0)
  {

    printf("(vdim of %s- primary part is %s)",i,vdim(L[i][1]));

  }

  L[i][2] = groebner(L[i][2]);

  d       = dim(L[i][1]);

  printf("dim of %s-   prime part is %s",i,d);

  if (d==0)
  {

    printf("(vdim of %s-   prime part is %s)",i,vdim(L[i][2]));
  }
}


// CONCLUSIONS: 
// L[3],...,L[6] are real solutions, e.g.

L[5];

// L[7], L[8] are complex solutions, e.g.

L[8];

// L[1], L[2] to be further investigated (not 0-dim)
// since zt+-1 are in the ideal, {z,t} can never be 0

ring rt  = (0,t),(x,y,z),dp;

list   L = imap(r,L);

ideal I1 = groebner(L[1][2]);

I1 = normalize(I1);

ideal I2 = groebner(L[2][2]);

I2 = normalize(I2);

// and we have obtained the t-parametric family of solutions

// ALTERNATIVE: let us decompose the radical!

setring r;

ideal K = radical(J);

list LK = minAssChar(K);

LK;

// and these objects are already known to us
