// APPLICATION OF MODULES
// Two Pendula, mounted on a cart


LIB "poly.lib";

ring R = (0,m1,m2,M,g,L1,L2), Dt, dp;

module T =
[m1*L1*Dt^2, m2*L2*Dt^2, -1, (M+m1+m2)*Dt^2],
[m1*L1^2*Dt^2-m1*L1*g, 0, 0, m1*L1*Dt^2],
[0, m2*L2^2*Dt^2-m2*L2*g, 0, m2*L2*Dt^2];

T = transpose(T);

option(redSB); option(redTail);

module W = groebner(T);

print(W);

module L = lift(T,W); // transformation matrix

print(T*matrix(L)- W);

number n2 = content(L[2]); 
number n3 = content(L[3]);

ideal I = 1/n2, 1/n3; I;

ring RP = (0,g),(m1,m2,M,L1,L2), dp;

ideal I = imap(R,I);

facstd(I); // factorizing Groebner

// check the case L1 = L2!

ring RR = (0,m1,m2,M,g,L), Dt, dp;

module T =
[m1*L*Dt^2, m2*L*Dt^2, -1, (M+m1+m2)*Dt^2],
[m1*L^2*Dt^2-m1*L*g, 0, 0, m1*L*Dt^2],
[0, m2*L^2*Dt^2-m2*L*g, 0, m2*L*Dt^2];

T = transpose(T);

option(redSB);

module W = groebner(T);

print(W);

print(prune(W));

kill RP; kill R; kill RR;
